﻿using AutomobilePlantDataModels.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.ComponentModel;
using AutomobilePlantDataModels.Enums;

namespace AutomobilePlantContracts.ViewModel
{
    public class OrderViewModel : IOrderModel
    {
        [DisplayName("Номер")]
        public int Id { get; set; }
        [DisplayName("Клиент")]
        public string ClientName { get; set; } = string.Empty;
        public int ClientId { get; set; }
        public int? ImplementerId { get; set; }
        [DisplayName("Исполнитель")]
        public string? ImplementerName { get; set; } = string.Empty;
        public int CarId { get; set; }
        [DisplayName("Изделие")]
        public string CarName { get; set; } = string.Empty;
        [DisplayName("Количество")]
        public int Count { get; set; }
        [DisplayName("Сумма")]
        public double Sum { get; set; }
        [DisplayName("Статус")]
        public OrderStatus Status { get; set; } = OrderStatus.Неизвестен;
        [DisplayName("Дата создания")]
        public DateTime DateCreate { get; set; } = DateTime.SpecifyKind(DateTime.Now, DateTimeKind.Utc);
        [DisplayName("Дата выполнения")]
        public DateTime? DateImplement { get; set; }

    }
}
