﻿using AutomobilePlantContracts.BindingModels;
using AutomobilePlantContracts.ViewModel;
using AutomobilePlantDataModels.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Linq;

namespace AutomomilePlantFileImplement.Models
{
    public class Implementer : IImplementerModel
    {
        public int Id { get; private set; }
        public string ImplementerFIO { get; private set; } = string.Empty;
        public int WorkExperience { get; set; }
        public int Qualification { get; set; }
        public string Password { get; private set; } = string.Empty;
        public static Implementer? Create(ImplementerBindingModel model)
        {
            if (model == null)
            {
                return null;
            }
            return new Implementer()
            {
                Id = model.Id,
                ImplementerFIO = model.ImplementerFIO,
                WorkExperience = model.WorkExperience,
                Qualification = model.Qualification,
                Password = model.Password,
            };
        }
        public static Implementer? Create(XElement element)
        {
            if (element == null)
            {
                return null;
            }
            return new Implementer()
            {
                Id = Convert.ToInt32(element.Attribute("Id")!.Value),
                ImplementerFIO = element.Element("ImplementerFIO")!.Value,
                WorkExperience = Convert.ToInt32(element.Attribute("WorkExperience")!.Value),
                Qualification = Convert.ToInt32(element.Attribute("Qualification")!.Value),
                Password = element.Element("Password")!.Value,
            };
        }
        public void Update(ImplementerBindingModel model)
        {
            if (model == null)
            {
                return;
            }
            ImplementerFIO = model.ImplementerFIO;
            WorkExperience = model.WorkExperience;
            Qualification = model.Qualification;
            Password = model.Password;
        }
        public ImplementerViewModel GetViewModel => new()
        {
            Id = Id,
            ImplementerFIO = ImplementerFIO,
            WorkExperience = WorkExperience,
            Qualification=Qualification,
            Password = Password,
        };
        public XElement GetXElement => new("Implementer",
        new XAttribute("Id", Id),
        new XElement("ImplementerFIO", ImplementerFIO),
        new XElement("WorkExperience", WorkExperience),
        new XElement("Qualification", Qualification),
        new XElement("Password", Password)
            );
    }
}
